#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Green
#property  indicator_width1  2
#property  indicator_color2  YellowGreen
#property  indicator_width2  2
#property  indicator_color3  Red
#property  indicator_width3  2
#property  indicator_color4  DarkOrange
#property  indicator_width4  2
#property indicator_minimum -0.5
#property indicator_maximum 0.5
#property  indicator_level1 -0.3
#property  indicator_level2 0
#property  indicator_level3 0.3
#property  indicator_levelcolor DimGray 

extern int Dem_Period = 14;


double dem[];
double slope[];
double ind_buffer1[];
double ind_buffer2[];
double ind_buffer1s[];
double ind_buffer2s[];
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);

   SetIndexBuffer(0,ind_buffer1);
   SetIndexBuffer(1,ind_buffer1s);
   SetIndexBuffer(2,ind_buffer2);
   SetIndexBuffer(3,ind_buffer2s);
   SetIndexBuffer(4,dem);
   SetIndexBuffer(5,slope);
     
   IndicatorShortName("Dem("+Dem_Period+")");

   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);


   for(int i=limit; i>=0; i--)
   {
      ind_buffer1[i]  = EMPTY_VALUE;
      ind_buffer1s[i] = EMPTY_VALUE;    
      ind_buffer2[i]  = EMPTY_VALUE;
      ind_buffer2s[i] = EMPTY_VALUE;
      dem[i]   = iDeMarker(NULL,0,Dem_Period,i)-0.5;
      slope[i] = slope[i+1];
         if (dem[i] > dem[i+1]) slope[i] =  1;
         if (dem[i] < dem[i+1]) slope[i] = -1;
         if (dem[i] > 0)
            if (slope[i] == 1)
                  ind_buffer1[i]  = dem[i];
            else  ind_buffer1s[i] = dem[i];
         else            
            if (slope[i] == -1)
                  ind_buffer2[i]  = dem[i];
            else  ind_buffer2s[i] = dem[i];
   }
   return(0);
}